/*
 * Copyright 2024, My Name <my@email.address>
 * All rights reserved. Distributed under the terms of the MIT license.
 */
#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <MenuItem.h>
#include <TextControl.h>
#include <TextView.h>
#include <StatusBar.h>
#include <Window.h>
#include <String.h>

#include "Conversation.h"
 

 
class MainWindow : public BWindow {
public:
  MainWindow();
  virtual ~MainWindow();

  virtual void MessageReceived(BMessage *msg);

  Conversation* _conversation = new Conversation(this);

private:


  BMenuBar *_BuildMenu();
  BTextView * _answerView;
  BTextView * _infoView;
  BTextView* _inputField;
  BStatusBar* _progress;
 
 // BMenuItem *fSaveMenuItem;
};

#endif
